<template>
  <div>
    <div
      style="min-width: 300px;"
      :style="'height:' + height + 'px'"
      ref="chart"
    />
    {{ labelRotation }}
    <v-row justify="center">
      <v-col class="text-center" md="6" lg="6" xl="6">
        <strong>Simbología:</strong>
      </v-col>
    </v-row>
    <v-row style="min-height:70px;" justify="center">
      <v-col class="text-sm-center" cols="12" sm="4" md="3" lg="2" xl="4">
        <v-card
          class="d-inline-block mr-2"
          color="grey"
          width="20"
          height="20"
          tile
          elevation="0"
        />
        <span class="font-weight-black">{{
          data.graficaLeyends.categorys.left
        }}</span>
      </v-col>
      <v-col class="text-sm-center" cols="12" sm="4" md="3" lg="2" xl="4">
        <v-card
          class="d-inline-block rounded-circle mr-2"
          color="green"
          width="15"
          height="15"
          tile
          elevation="0"
        />
        <span class="font-weight-black">{{
          data.graficaLeyends.categorys.right
        }}</span>
      </v-col>
      <v-col
        class="text-sm-center"
        cols="12"
        sm="4"
        md="3"
        lg="2"
        xl="4"
        v-if="data.graficaLeyends.categorys.goal && data.goal"
      >
        <v-card
          class="d-inline-block mr-2"
          color="#0277BD"
          width="35"
          height="3"
          tile
          elevation="0"
        />
        <span class="font-weight-black">{{
          data.graficaLeyends.categorys.goal
        }}</span>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);
export default {
  name: "Component-Barras",
  props: {
    height: {
      required: false,
      default: 440,
      type: [Number, String],
    },
    data: {
      required: true,
      default() {
        return {
          title: null,
          color: null,
          goal: null,
          graficaLeyends: {
            titles: {},
            categorys: {},
          },
          values: [],
        };
      },
      type: Object,
    },
  },
  data() {
    return {
      chart: null,
      axisTitleVerticalLeft: null,
      axisTitleVerticalRight: null,
      axisTitlesHorizontal: null,
    };
  },
  computed: {
    labelRotation() {
      let chart = this.chart;
      let axisTitleVerticalLeft = this.axisTitleVerticalLeft;
      let axisTitleVerticalRight = this.axisTitleVerticalRight;
      let axisTitlesHorizontal = this.axisTitlesHorizontal;

      if (chart) {
        axisTitleVerticalLeft.disabled = true;
        axisTitleVerticalRight.disabled = true;
        axisTitlesHorizontal.disabled = true;
        let categoryAxis = chart.xAxes.values[0];
        if (
          this.$vuetify.breakpoint.name === "sm" ||
          this.$vuetify.breakpoint.name === "xs"
        ) {
          if (!chart.scrollbarX) {
            chart.scrollbarX = new am4core.Scrollbar();
            chart.scrollbarX.thumb.minWidth = 100;
            chart.cursor = new am4charts.XYCursor();
            chart.cursor.behavior = "panX";
          }
          axisTitleVerticalLeft.disabled = false;
          axisTitleVerticalRight.disabled = false;
        } else {
          chart.scrollbarX = null;
          axisTitlesHorizontal.disabled = false;
        }
        categoryAxis.renderer.grid.template.location = 0;
        categoryAxis.renderer.minGridDistance = 15;
        categoryAxis.renderer.grid.template.location = 0;
        categoryAxis.renderer.grid.template.strokeDasharray = "1,3";
        categoryAxis.renderer.labels.template.rotation = -45;
        categoryAxis.renderer.labels.template.horizontalCenter = "middle";
        categoryAxis.renderer.labels.template.location = 0.52;
      }
      return "";
    },
  },
  methods: {
    buildChart() {
      let chart = this.chart;
      chart.logo.dom.style.display = "none";
      chart.responsive.enabled = true;

      // Add data
      chart.data = this.data.values;
      chart.plotContainer.background.strokeWidth = 1;
      chart.plotContainer.background.strokeOpacity = 1;
      chart.plotContainer.background.stroke = "grey";

      // Create axes
      var categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "categoria";
      categoryAxis.renderer.grid.template.location = 0;
      categoryAxis.tooltip.disabled = true;
      categoryAxis.renderer.grid.template.disabled = true;
      categoryAxis.renderer.labels.template.adapter.add("dx", function(
        dx,
        target
      ) {
        return -target.maxRight / 2;
      });
      categoryAxis.events.on("sizechanged", function(ev) {
        let axis = ev.target;
        let cellWidth = axis.pixelWidth / (axis.endIndex - axis.startIndex);
        axis.renderer.labels.template.maxWidth = cellWidth;
      });

      var labelsCategory = categoryAxis.renderer.labels.template;
      labelsCategory.wrap = true;
      labelsCategory.maxWidth = 100;
      labelsCategory.contentAlign = "right";
      labelsCategory.textDecoration = "underline";
      labelsCategory.fontSize = 10;
      labelsCategory.cursorOverStyle = am4core.MouseCursorStyle.pointer;
      labelsCategory.events.on(
        "hit",
        (ev) => {
          let index = ev.target.dataItem.index;
          let data = this.data.values[index];
          this.$emit("categoryClicked", data);
        },
        this
      );

      var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.minWidth = 50;
      valueAxis.renderer.grid.template.disabled = true;
      valueAxis.min = 0;
      valueAxis.cursorTooltipEnabled = false;
      valueAxis.title.fontFamily = "Avenir_Next_Demi_Bold";
      valueAxis.title.fontSize = 14;
      valueAxis.title.text = this.data.graficaLeyends.titles.left;
      valueAxis.title.disabled = true;

      var labelsValueAxis = valueAxis.renderer.labels.template;
      labelsValueAxis.fill = this.data.color;

      let topContainer = chart.chartContainer.createChild(am4core.Container);
      topContainer.layout = "absolute";
      topContainer.toBack();
      topContainer.paddingBottom = 15;
      topContainer.width = am4core.percent(100);

      let axisTitle = topContainer.createChild(am4core.Label);
      axisTitle.text = this.data.graficaLeyends.titles.left;
      axisTitle.fontFamily = "Avenir_Next_Demi_Bold";
      axisTitle.fontSize = 14;
      axisTitle.align = "left";

      let axisTitle2 = topContainer.createChild(am4core.Label);
      axisTitle2.text = this.data.graficaLeyends.titles.right;
      axisTitle2.fontFamily = "Avenir_Next_Demi_Bold";
      axisTitle2.fontSize = 14;
      axisTitle2.align = "right";

      // Create series
      var series = chart.series.push(new am4charts.ColumnSeries());
      series.sequencedInterpolation = true;
      series.dataFields.valueY = "valor";
      series.dataFields.categoryX = "categoria";
      series.tooltip.pointerOrientation = "vertical";

      var valueLabel = series.bullets.push(new am4charts.LabelBullet());
      valueLabel.label.text = "{valor}";
      valueLabel.label.fontSize = 20;
      valueLabel.locationY = 0.5;

      var columnTemplate = series.columns.template;
      columnTemplate.column.fillOpacity = 1;
      columnTemplate.strokeWidth = 0;
      columnTemplate.fill = this.data.color;

      // on hover, make corner radiuses bigger
      var hoverState = columnTemplate.states.create("hover");
      hoverState.properties.fillOpacity = 0.4;

      var escalaValueAxis = chart.yAxes.push(new am4charts.ValueAxis());
      escalaValueAxis.renderer.opposite = true;
      escalaValueAxis.min = 0;
      if (this.data.goal) {
        escalaValueAxis.max = 100;
        escalaValueAxis.strictMinMax = true;
      }
      var labelsEscalaValueAxis = escalaValueAxis.renderer.labels.template;
      labelsEscalaValueAxis.fill = "green";
      /*escalaValueAxis.renderer.minGridDistance = 70;*/
      escalaValueAxis.renderer.grid.template.disabled = true;
      escalaValueAxis.numberFormatter = new am4core.NumberFormatter();
      escalaValueAxis.numberFormatter.numberFormat = "#";
      escalaValueAxis.cursorTooltipEnabled = false;
      escalaValueAxis.title.fontFamily = "Avenir_Next_Demi_Bold";
      escalaValueAxis.title.fontSize = 14;
      escalaValueAxis.title.text = this.data.graficaLeyends.titles.right;
      escalaValueAxis.title.disabled = true;

      if (this.data.goal) {
        // goal guides
        var axisRange = escalaValueAxis.axisRanges.create();
        axisRange.value = this.data.goal;
        if (this.data.graficaLeyends.titles.goal) {
          axisRange.label.text = this.data.graficaLeyends.titles.goal;
          axisRange.label.align = "right";
          axisRange.label.fontFamily = "Avenir_Next_Demi_Bold";
          axisRange.label.fontSize = 14;
          axisRange.label.verticalCenter = "middle";
        }
        axisRange.grid.stroke = "#0277BD";
        axisRange.grid.strokeWidth = 2;
        axisRange.grid.strokeOpacity = 1;
      }

      var escalaSeries = chart.series.push(new am4charts.LineSeries());
      escalaSeries.dataFields.valueY = "calificacion";
      escalaSeries.dataFields.categoryX = "categoria";
      escalaSeries.yAxis = escalaValueAxis;
      //escalaSeries.tooltipText = "calificacion: {valueY.formatNumber('#.0')}%[/]";
      escalaSeries.strokeWidth = 2;
      escalaSeries.strokeDasharray = "4,6";
      escalaSeries.stroke = "green";
      escalaSeries.strokeOpacity = 0.8;

      var valueBulletsLabel = escalaSeries.bullets.push(
        new am4charts.LabelBullet()
      );
      valueBulletsLabel.label.fill = "green";
      valueBulletsLabel.label.text = "{calificacion}";
      valueBulletsLabel.label.fontSize = 15;
      valueBulletsLabel.dx = 15;
      valueBulletsLabel.dy = 15;

      let bullet = escalaSeries.bullets.push(new am4charts.CircleBullet());
      bullet.strokeWidth = 2;
      bullet.fill = "green";
      bullet.stroke = "green";
      bullet.setStateOnChildren = true;
      bullet.propertyFields.fillOpacity = "opacity";
      bullet.propertyFields.strokeOpacity = "opacity";

      this.axisTitleVerticalLeft = escalaValueAxis.title;
      this.axisTitleVerticalRight = valueAxis.title;
      this.axisTitlesHorizontal = topContainer;
    },
    renderChart() {
      this.$nextTick(() => {
        this.disposeChart();
        let chart = this.$refs.chart;
        this.chart = am4core.create(chart, am4charts.XYChart);
        this.buildChart();
      });
    },
    disposeChart() {
      if (this.chart) {
        this.chart.dispose();
      }
    },
  },
  beforeDestroy() {
    this.disposeChart();
  },
  mounted() {
    if (!this.chart) {
      this.renderChart();
    }
  },
};
</script>
